package launcher;

import javafx.application.Application;
import javafx.stage.Stage;
import model.*;

import java.io.IOException;
import java.util.Map;

public class Launch extends Application {
    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) throws IOException, InterruptedException {
        StrategyRandom captorS = new StrategyRandom(1,"Capteur Simple");
        CapteurIntervalle captorI = new CapteurIntervalle(2,"Capteur Intervalle",0.0,10.0);
        CapteurRealiste captorR = new CapteurRealiste(3,"Capteur Realiste", 5.0, 10.0);
        CapteurCPU captorC = new CapteurCPU(4,"Capteur CPU");
        CapteurVirtuel captorV = new CapteurVirtuel(5,"CapteurVirtuel");

        captorV.addCapteur(captorS,1);
        captorV.addCapteur(captorI,1);
        captorV.addCapteur(captorC,1);
        captorV.addCapteur(captorR,1);

        // FXML NOT WORKING
        /*Stage thermostatStage = new Stage();
        CapteurView capteurView = new ImageCtrlView(captor,"view/Image.fxml","mon titre");
        ThermostatView thermostatView = new ThermostatView(captor,"view/Thermostat.fxml","mon titre");
        */
        //Random random = new Random();

        Thread t = new Thread() {
            public void run() {
                while (true) {
                    captorV.genTemp();
                    try {
                        System.out.println(captorV.getNom() + ": " + captorV.getTemp().getValue() + " °C");
                        for (Map.Entry<CapteurAbstrait, Integer> entry : captorV.getCapteurs().entrySet()) {
                            CapteurAbstrait c = entry.getKey();
                            c.genTemp();
                            System.out.println(c.getNom() + ": " + c.getTemp().getValue() + " °C");
                            System.out.println(c.getNom() + ": " + c.getTemp().getValue() + " °C");
                        }

                        sleep(4000);
                    } catch (InterruptedException e) {
                        throw new RuntimeException(e);
                    }
                }
            }
        };
        t.start();
    }
}

